/*
 * dongle_custom.c
 *
 *  Created on: 2014-3-10
 *      Author: sihui
 */

#include "../../proj/tl_common.h"
#include "../../proj/mcu/watchdog_i.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../common/rf_frame.h"
#include "../common/emi.h"

#include "dongle_custom.h"
#include "dongle_usb.h"

#define CUSTOM_TEST_DEBUG     0

void (*device_program)(int adr, unsigned char id);
void (*device_program_on)(void);
void (*device_program_off)(void);

void otp_device_program_on(void);
void otp_device_program_off(void);
void otp_device_program(int, unsigned char);

void flash_device_program_on(void);
void flash_device_program_off(void);
void flash_device_program(int, unsigned char);

u32 dongle_id = 0;

custom_cfg_t   *p_custom_cfg;

u32     rf_paring_tick = 0;
AES_KEY	enc_key[2];
//u8 key_index=0;



int		custom_binding_idx;

s8 		custom_rssi_paring_th_offset;
s8 		custom_auto_paring_rssi;
u8      dongle_custom_cap;

int     id_check_flg;

s8     rf_pair_enable=1;//must init
//s8     keyboard_paring_enable;
//s8     mouse_paring_enable;

//s8     golden_dongle_enable;
//s8     auto_paring_enable;
//s8     auto_paring_enable_m2;

//s8     soft_paring_enable;
//s8     manual_paring_enable;

s8     dongle_support_keyboard_enable;

//u8      channel_mask_custom;
u8   conn_mcu_type;

u8 pair_type;
//u8 mem_type=0;


u32 addr_save=0;
u16 max_num_save=0;


void dongle_emi_cust_init(void)
{
    write_reg8(0x800598, read_reg8(0x800598) & 0xf0);   //8366 disable mspi IO drive-strenth to satisfy 192M
}
void clear_pair_flag()
{
	rf_pair_enable=0;
	rf_receiving_pipe_enble(0x06);
}
void set_pair_flag()
{
	rf_pair_enable=1;
	rf_receiving_pipe_enble(0x07);
	rf_paring_tick=clock_time()|1;
}

 u8 pub_key[16] =
{
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, 0x10
};
 u8 last_device_type=0xff;

 
void set_aes_key(u8 key_index)
{
   if(last_device_type!=key_index)
   {
   		last_device_type=key_index;
	#if (AES_METHOD ==1)
		user_rijndaelSetKey(pub_key,1);
	#elif ((AES_METHOD ==2))
		user_rijndaelSetKey((u8*)&enc_key[key_index].did,1);
	#elif ((AES_METHOD ==3))
		user_rijndaelSetKey((u8*)&enc_key[key_index].did,0);
	#endif
   }


	
}
u32 bin_crc;
void	custom_init(void)
{

	u32 *addr_bin_size=(u32*)(0x18);
	u32 *addr_crc=(u32*)(addr_bin_size[0]-4);
	bin_crc=addr_crc[0];
    
#if(CUSTOM_DATA_ERR_FIX_ENABLE)
    for (int i = 0; i < CUSTOM_DATA_MAX_COUNT; i++)
    {
        p_custom_cfg = (custom_cfg_t *)(DEVICE_CUSTOMIZATION_INFO_ADDR + (i * 22)); //3f00
        if (p_custom_cfg->paring_limit_t != 0)
        {
            break;
        }
    }
#else
    p_custom_cfg = (custom_cfg_t *)(DEVICE_CUSTOMIZATION_INFO_ADDR);  //3f00
#endif


 	 //aes Key
    for (u8 i = 0; i < 16; i++)
    {
        if (p_custom_cfg->encKey[0]!= 0xff)
        {
            memcpy(pub_key, &p_custom_cfg->encKey[0], 16);
            break;
        }
    }

    u16 custom_id;
    custom_id                      = p_custom_cfg->vid;
    if (custom_id != U16_MAX)
    {
        rf_set_access_code0(rf_access_code_16to32(custom_id));
    }

    u32 d_id;
	
#if 	CUSTOM_TEST_DEBUG
    d_id=0x59456e;
#else
    d_id = p_custom_cfg->id_4;

#endif
    if (d_id != U32_MAX)
    {
        u32 code = rf_access_code_24to32(d_id);
        rf_set_access_code1(code);
    }
    dongle_id = rf_get_access_code1();
    

    conn_mcu_type = p_custom_cfg->conn_mcu_type;

#if DONGLE_CUS_EN
    dongle_custom_cap              = p_custom_cfg->cap;
    if (p_custom_cfg->cap != U8_MAX)
        cap_internal_adjust(p_custom_cfg->cap);

    pair_type = MANUAL_PARING_TYPE;//((p_custom_cfg->paring_type == U8_MAX) ? 0xaf : p_custom_cfg->paring_type);

   
#else
    auto_paring_enable = 1;
#endif																		//paring time limit

#if DONGLE_CUS_EN
    dongle_support_keyboard_enable = (p_custom_cfg->support_type != U8_MAX);
   
    custom_rssi_paring_th_offset   = (p_custom_cfg->rssi_threshold == U8_MAX) ? 0 : p_custom_cfg->rssi_threshold;
    //custom_auto_paring_rssi        = (p_custom_cfg->rssi_threshold == U8_MAX) ? 65 : p_custom_cfg->rssi_threshold;
    //channel_mask_custom            = p_custom_cfg->channal_msk;

   // rf_paring_enable       = 1;//manual_paring_enable || auto_paring_enable_m2;
#endif
#if 	CUSTOM_TEST_DEBUG
    dongle_support_keyboard_enable=1;
#endif
  
#if(USB_DESCRIPTER_CONFIGURATION_FOR_KM_DONGLE)  //for km dongle customization (add by sihui)
    get_usb_descripter_configuration();
#endif
     
#if DONGLE_ID_IN_FW

#if 	CUSTOM_TEST_DEBUG
	if (0)
#else
    if (p_custom_cfg->memory_type == U8_MAX)
#endif	
    {
		//mem_type=0;
		addr_save=DEVICE_PARING_INFO_ADDR;
		max_num_save=DID_PARING_MAX;
		device_program = otp_device_program;
        device_program_on = otp_device_program_on;
        device_program_off = otp_device_program_off;
    }
    else
    {
		//mem_type=1;
		addr_save=FLASH_DEVICE_PARING_INFO_ADDR;
		max_num_save=FLASH_DID_PARING_MAX;
		device_program = flash_device_program;
        device_program_on = flash_device_program_on;
        device_program_off = flash_device_program_off;
    }
#endif

    id_check_flg = p_custom_cfg->id_check == U8_MAX;
    if (p_custom_cfg->emi_ini_patch != U8_MAX)
        pf_emi_cust_init = dongle_emi_cust_init;

    u8 *p = (u8 *) addr_save;
    for (custom_binding_idx = 0; custom_binding_idx < max_num_save; custom_binding_idx++)
    {
        if (p[3] == 0xff)
            break;
		memcpy(&enc_key[(p[3]-FRAME_TYPE_MOUSE)&1].did,&p[0],16);
		
        p += ID_LEN;
    }

}

#if DONGLE_ID_IN_FW
/****************************************************************************************************************
     set_device_id_in_firmware
     load paired device id into flash and ram
 ***************************************************************************************************************/
#if 0
int set_device_id_in_firmware111(int type, u32 id)
{
    int ret = 1;
    if (custom_binding[type] == id)
    {
        //do nothing
    }
    else if (custom_binding_idx < max_num_save)
    {
		u32 adr =0;
		if(mem_type)//flash
		{
			adr = (addr_save + 8 * custom_binding_idx);
		}
		else
		{
			adr = (addr_save + 6 * custom_binding_idx);
		}
		

        device_program_on();
        device_program(adr, type);
        device_program(adr + 2, id);
        device_program(adr + 3, id >> 8);
        device_program(adr + 4, id >> 16);
        device_program(adr + 5, id >> 24);
        device_program_off();

        if (id_check_flg)
        {
            u8 temp = *(volatile u8 *)(adr);
            temp = *(volatile u8 *)(adr + 1024);
            temp = *(volatile u8 *)(adr + 2 * 1024);

            u8 type_read =  *(volatile u8 *)(adr);
            u16 id_read_low = *(volatile u16 *)(adr + 2);
            u16 id_read_high = *(volatile u16 *)(adr + 4);

            if (type_read != type || ((id_read_high << 16) | id_read_low) != id)
            {
                return 0;
            }
        }

        custom_binding[type & 1] = id;
        custom_binding_idx ++;
    }
    else
    {
        ret = 0;
    }
    return ret;
}
#endif
/****************************************************************************************************************
     set_device_id_in_firmware
     load paired device id into flash and ram
 ***************************************************************************************************************/
int set_device_id_in_firmware(u8 *p)
{
	rf_packet_pairing_t *p_pkt = (rf_packet_pairing_t *)(p + 8);
	u8 dec[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#if ((AES_METHOD==0)||(AES_METHOD==1))	
	memcpy(&dec[0],&p_pkt->did,ID_LEN);
#elif (AES_METHOD==2)
	user_rijndaelSetKey(pub_key,1);
	aes_user_ecb_encryption((u8 *)&p_pkt->did,&dec[0]);
#elif (AES_METHOD==3)
	user_rijndaelSetKey(pub_key,0);
	aes_user_ecb_encryption((u8 *)&p_pkt->did,&dec[0]);	
#endif

#if GOLD_TEST_DONGLE
	 memcpy(&enc_key[p_pkt->type-FRAME_TYPE_MOUSE].did,dec,ID_LEN);

		return 1;
#else

    if(memcmp(&dec[0],&enc_key[p_pkt->type-FRAME_TYPE_MOUSE].did,ID_LEN)==0)
    {
		return 1;
    } 
    else if (custom_binding_idx < max_num_save)
    {
		u32 adr =0;
		
		adr = (addr_save + ID_LEN * custom_binding_idx);
        

        device_program_on();

       for(u8 i=0;i<ID_LEN;i++)
       {
	   		device_program(adr+i, dec[i]);
       }
		
        device_program_off();
#if 0
        if (id_check_flg)
        {
            u8 temp = *(volatile u8 *)(adr);
            temp = *(volatile u8 *)(adr + 1024);
            temp = *(volatile u8 *)(adr + 2 * 1024);

            u8 type_read =  *(volatile u8 *)(adr);
            u16 id_read_low = *(volatile u16 *)(adr + 2);
            u16 id_read_high = *(volatile u16 *)(adr + 4);

            if (type_read != type || ((id_read_high << 16) | id_read_low) != id)
            {
                return 0;
            }
        }

        custom_binding[type & 1] = id;
#endif
	   memcpy(&enc_key[p_pkt->type-FRAME_TYPE_MOUSE].did,dec,ID_LEN);

        custom_binding_idx ++;
		return 1;
    }
    
    return 0;
#endif
}


/****************************************************************************************************************
     device_program_on
     device_program
     device_program_off
 ***************************************************************************************************************/

//#if (OTP_PROGRAM)

//////////////////////////////////////////////////////
//copy from  dut otp code
//////////////////////////////////////////////////////
void otp_device_program_on(void)
{
    /* open vpp 6.75V */
    unsigned char irqst = read_reg8(0x800643);
    write_reg8(0x800643, 0);

    write_reg8(0x800071, 0x13);;    // set DCDC 6.75 clk to 60M
    sleep_us(100);
    analog_write(0x85, 0x14);
    sleep_us(1000);   //wait at least 1000us
    analog_write(0x85, 0x54);
    sleep_us(100);

    write_reg8(0x800643, irqst);
}

void otp_device_program_off(void)
{
    analog_write(0x85, 0x0c);
    write_reg8(0x800071, 0x03);
}


_attribute_ram_code_ void otp_device_program(int addr, unsigned char value)
{
    unsigned char irqst = read_reg8(0x800643);
    write_reg8(0x800643, 0);

    write_reg8(0x800012, 0x7e);
    write_reg16(0x800010, addr);
    write_reg8(0x80001a, 0x02);
    write_reg8(0x800013, value);
    WaitUs(100);
    write_reg8(0x800013, value);
    write_reg8(0x80001a, 0x0);
    WaitUs(20);

    write_reg8(0x800643, irqst);
}

//#else

void flash_device_program_on(void) {}
void flash_device_program_off(void) {}
//flash program to emulate OTP
_attribute_ram_code_ void flash_device_program(int adr, unsigned char id)
{
    unsigned char irqst = read_reg8(0x800643);
    write_reg8(0x800643, 0);
    write_reg8(0x80000d, 0x00);
    write_reg8(0x80000c, 0x06);	//write enable
    while (read_reg8(0x80000d));
    write_reg8(0x80000d, 0x01);

    WaitUs(1);

    write_reg8(0x80000d, 0x00);
    write_reg8(0x80000c, 0x02);	//write command
    while (read_reg8(0x80000d));

    write_reg8(0x80000c, adr >> 16);
    while (read_reg8(0x80000d));

    write_reg8(0x80000c, adr >> 8);
    while (read_reg8(0x80000d));

    write_reg8(0x80000c, adr);
    while (read_reg8(0x80000d));

    write_reg8(0x80000c, id);
    while (read_reg8(0x80000d));

    write_reg8(0x80000d, 0x01);
#if 0
    write_reg8(0x80000d, 0x00);
    write_reg8(0x80000c, 0x05);	//read status
    while (read_reg8(0x80000d));
    int i;
    for (i = 0; i < 1000000; i++)
    {
        write_reg8(0x80000c, 0x00);	//launch 8-cycle to trigger read
        while (read_reg8(0x80000d));
        if (!(read_reg8(0x80000c) & 1))
            break;
    }
    write_reg8(0x80000d, 0x01);
#else
    WaitUs(1000);
#endif
    write_reg8(0x800643, irqst);
}
//#endif
#endif

/****************************************************************************************************************
     paring_time_check
 ***************************************************************************************************************/
void paring_time_check(void)
{

    {
        if (rf_paring_tick && clock_time_exceed(rf_paring_tick, custom_dongle_time_limit()))
        {
			rf_paring_tick=0;
			clear_pair_flag();
        }
    }

}

