/*
 * dongle_custom.h
 *
 *  Created on: 2014-3-10
 *      Author: hp
 */

#ifndef DONGLE_CUSTOM_H_
#define DONGLE_CUSTOM_H_

#ifndef DONGLE_CUS_EN
    #define DONGLE_CUS_EN		1
#endif

#ifndef	DONGLE_ID_IN_FW
    #define DONGLE_ID_IN_FW		1
#endif

#include "../common/user_config.h"

void      custom_init(void);
void 	  paring_time_check(void);

#define 	RECV_PKT_RSSI(p)                (((u8 *)p)[4])


/********************************************************
paring_type customization
addr :  0x3f05
default  0xff:  auto			   1111 1111	->0xaf
         0xcf:  soft        	   1100 1111
         0xa7:  auto_m2			   1010 0111
		 0xfb:	manual             1111 1011
         0x6f:  golden dongle	   0110 1111

 *******************************************************/
#define		CUSTOM_DONGLE_GOLDEN			BIT(7)     // 0 for golden dongle
#define		CUSTOM_DONGLE_AUTO_PARING		BIT(6)     // 0 for  auto paring
#define		CUSTOM_DONGLE_SOFT_PARING		BIT(5)     // 0 for software paring

#define		CUSTOM_DONGLE_AUTO_PARING_M2	BIT(3)     // 0 for  munaul  paring
#define		CUSTOM_DONGLE_MANNUAL_PARING	BIT(2)     // 0 for  munaul  paring

/********************************************************
support_type customization
addr  :  0x3f07
default  0xff  :  mouse only
         other :  mouse/keyboard kit
 *******************************************************/


/***********************************************************************************
vendor  string : addr 0x3de0   max_len:22 characters   default : Telink
product string : addr 0x3e40   max_len:22 characters   default : Wireless Receiver
serial  string : addr 0x3ea0   max_len:22 characters   default : TLSR8366
 **********************************************************************************/
#define     VENDOR_STRING_ADDR              0x3e00
#define     PRODCT_STRING_ADDR              0x3e40
#define     SERIAL_STRING_ADDR              0x3ea0

//otp
#define DEVICE_PARING_INFO_ADDR         0x3c00   //3c00~3dff  //Ϣַ
#define	DID_PARING_MAX			32

//flash
#define FLASH_DEVICE_PARING_INFO_ADDR 0x4000  //0x4000~0x5fff Ϣַ
#define FLASH_DID_PARING_MAX  512

/***********************************************************************************
OTP жϢд޸ƿ  CUSTOM_DATA_ERR_FIX_ENABLE
		          дϢ CUSTOM_DATA_MAX_COUNT
 **********************************************************************************/
#define		CUSTOM_DATA_ERR_FIX_ENABLE      1
#define		CUSTOM_DATA_MAX_COUNT		    2

//cust_crystal_12M: the first custom info
//#define		cust_crystal_12M	( (*(unsigned char*) (DEVICE_CUSTOMIZATION_INFO_ADDR - 1)) == 0 )    //( custom_cfg_t->crystal_12M )
typedef struct
{
    u16  vid;		  		  // 00~0x01 vendor id
    u16  id;		  		  // 02~0x03 device id
    u8	 cap;	           // 04 	crystal CAP setting
    u8	 paring_type;	   // 05 	paring_type
    u8   paring_limit_t;   // 06    manual_paring_time_set(4 s unit)   @@@@@as wrong_info flg if set to 0
    u8	 support_type;     // 07 	BIT7|BIT6  10:mouse_only   01:keyboard_only    11:mouse and keyboard
    u8	 rssi_threshold;   // 08
    u8   channal_msk;      // 09
    u8 	 report_type;      // 0a    default for mouse report rate 125,other for 250
    u16  vendor_id;        // 0b-0c
    u16  prodct_id;        // 0d-0e
    u8   tx_power_emi;     // 0f

    u8   memory_type;      // 10  0xff for otp,0 for flash
    u8   id_check;         // 11  0xff: check paring id,   0: not check
    u8   emi_ini_patch;    // 12  0xff: patch nothing,   0: some-board must disable mspi driver strength to pass emi 192M

#if 1//(CAVY_HAMSTER_REMINGTON_COMPATIBLE_EN)
    u8   chn_type;	   // 13  0xff: for hamster chn,  0: for cavy chn
#endif
    u32 id_4;				// 14~17  device id(for 4bytes device id)
    u8  encKey[16];     //18~27 aes128 key 16bytes
    u8  conn_mcu_type;

} custom_cfg_t;
typedef struct
{
	u32 did;
	u8 key[12];
}AES_KEY;

extern AES_KEY	enc_key[2];
extern u8 key_index;




extern custom_cfg_t   *p_custom_cfg;
static inline u32 custom_dongle_time_limit()
{
    return (p_custom_cfg->paring_limit_t & 15) * 4000000;
}

#define dongle_cust_tx_power_emi         ( (p_custom_cfg->tx_power_emi == 0xff) ? RF_POWER_8dBm : p_custom_cfg->tx_power_emi )

extern s8 dongle_support_mouse_enable;
extern s8  dongle_support_keyboard_enable;

extern s8     keyboard_paring_enable;
extern s8     mouse_paring_enable;

/////////////////////////////////////////////
// dongle_custom.c  еı
/////////////////////////////////////////////
extern s8     rf_pair_enable;
//extern s8     golden_dongle_enable;
//extern s8     auto_paring_enable;
//extern s8     auto_paring_enable_m2;
//extern s8     soft_paring_enable;
//extern s8     manual_paring_enable;
extern s8 		custom_rssi_paring_th_offset;
extern u8		host_keyboard_status;
extern u8 pair_type;


//int set_device_id_in_firmware(int type, u32 id);
int set_device_id_in_firmware(u8 *p);
u8 check_from_ram(rf_packet_pairing_t *p);
void user_rijndaelSetKey(unsigned char *key , unsigned char need_dec);
void aes_user_ecb_encryption(u8 *plaintext, u8 *result);

void set_aes_key(u8 type);
extern u8 last_device_type;



extern u32 dongle_id;
void  aes_method_level_1_set_key();

void usbkb_hid_report(kb_data_t *data);
int usb_keyboard_hid_report_aaa(unsigned char *data);
int usb_mouse_hid_report_aaa(u8 report_id, u8 *data, int cnt);


void usbmouse_add_frame(rf_packet_mouse_t *packet_mouse);

void usb_handle_irq(void);
void aes_user_ecb_Decrypt(u8 *plaintext, u8 *result);
extern void clear_pair_flag();
void set_pair_flag();


extern void rf_receiving_pipe_enble(u8 channel_mask);

#endif /* DONGLE_CUSTOM_H_ */
