/*
 * dongle_suspend.c
 *
 *  Created on: 2014-7-10
 *      Author: Telink
 */

#include "../../proj/tl_common.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "dongle_suspend.h"


extern  u8  usb_has_suspend_irq;

int resume_host_flg;

#ifndef USB_REMOTE_WAKEUP_FEATURE_ENABLE
    #define USB_REMOTE_WAKEUP_FEATURE_ENABLE	1
#endif

void	dongle_resume_request()
{
    resume_host_flg = 1;
}
#if 0
int suspend_and_wakeup(void)
{

    static u32 tick = 0;
    static u32 tick_wakeup = 0;
    static int wakeup = 1;
    int allow_suspend = 0;

    if (!allow_suspend && clock_time_exceed(tick, 2000000))   //suspend allowed after power on for 2 seconds
        allow_suspend = 1;


    if (resume_host_flg)
    {
        if (reg_irq_src & FLD_IRQ_USB_PWDN_EN)
        {
            usb_resume_host();
        }
        resume_host_flg = 0;
    }

    if (!(reg_irq_src & FLD_IRQ_USB_PWDN_EN))
    {
        usb_has_suspend_irq = 0;
    }

    if (allow_suspend && usb_has_suspend_irq && wakeup
            && clock_time_exceed(tick_wakeup, 15 * 1000))   //PM_USB_WAKEUP_TIME
    {
        wakeup = 0;

        u8 r = irq_disable();			// must

        if (reg_usb_mdev & BIT(2))
        {
            cpu_sleep_wakeup_rc(0, PM_WAKEUP_CORE | PM_WAKEUP_TIMER, 200);
        }
        else
        {
            cpu_sleep_wakeup_rc(0, PM_WAKEUP_CORE, 200);
        }

        //restore
        clock_init();
        rf_drv_init(1);
        reg_tmr_ctrl |= FLD_TMR1_EN;
        extern  u8	host_channel;
        rf_set_channel(host_channel, RF_CHN_TABLE);
        rf_set_rxmode();
        irq_restore(r);
        tick_wakeup = clock_time();
        wakeup = 1;

    }
    return 1;
}
#endif

void usb_resume_host(void)
{
    if ((reg_usb_mdev & BIT(2)) && (reg_irq_src & FLD_IRQ_USB_PWDN_EN))     // (reg_usb_mdev & BIT(2))
    {
        reg_wakeup_en = FLD_WAKEUP_SRC_USB_RESM;
        reg_wakeup_en = FLD_WAKEUP_SRC_USB;
    }
}
u8 allow_suspend = 0;
//u32 tick_allow_suspend = 0;
u32 tick_host_start_power_on = 0;
u32 tick_host_start_power_off = 0;
u32 tick_suspend_interval;

u8 need_wake_up_host_flag = 0;
u32 tick_resume_host;
u8 allow_send_to_usb_flag = 1;



void mcu_enter_suspend()
{
    if (clock_time_exceed(tick_suspend_interval, 15000))
    {

        u8 r = irq_disable();			// must
        if (reg_usb_mdev & BIT(2))
        {
            cpu_sleep_wakeup_rc(0, PM_WAKEUP_CORE | PM_WAKEUP_TIMER, 200);
        }
        else
        {
            cpu_sleep_wakeup_rc(0, PM_WAKEUP_CORE, 200);
        }
        clock_init();
        rf_drv_init(1);
        reg_tmr_ctrl |= FLD_TMR1_EN;
        extern  u8	host_channel;
        rf_set_channel(host_channel, RF_CHN_TABLE);
        rf_set_rxmode();
        irq_restore(r);

        tick_suspend_interval = clock_time() | 1;
    }
}
void user_resume_host()
{
        allow_suspend=0;
		need_wake_up_host_flag=1;
		usb_resume_host();
}



void proc_suspend(void)
{

    if (reg_irq_src & FLD_IRQ_USB_PWDN_EN)
    {
        tick_host_start_power_on = clock_time() | 1;


        host_keyboard_status=0;
        allow_send_to_usb_flag = 0;
		 if (need_wake_up_host_flag)
		{
			
			
		}

       else if (tick_host_start_power_off)
        {
            if (clock_time_exceed(tick_host_start_power_off, 3500000))
            {
                tick_host_start_power_off = 0;
				tick_suspend_interval = clock_time();
               // tick_resume_host =tick_suspend_interval ;
                allow_suspend = 1;
			   need_wake_up_host_flag=0;
            }
        }
        else if (allow_suspend)
        {
            mcu_enter_suspend();
        }
		
    }
    else
    {
        tick_host_start_power_off = clock_time() | 1;
        need_wake_up_host_flag=0;
        if (tick_host_start_power_on&&clock_time_exceed(tick_host_start_power_on, 1000000))
        {
            allow_send_to_usb_flag = 1;
			u8 release_data[8] = {0,0,0,0,0,0,0,0};
			usb_mouse_hid_report_aaa(1,release_data,6);
			//usb_keyboard_hid_report_aaa(release_data);
			tick_host_start_power_on=0;
        }
    }
}


