
#include "../../proj/tl_common.h"

#if(!__PROJECT_PM_TEST__)

#include "../../proj/mcu/watchdog_i.h"
#include "../../vendor/common/user_config.h"

#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../../proj_lib/aes_sw/aes_sw.h"

extern void usb_init();
extern void user_init();
extern void main_loop();
extern void proc_button_ahead();
extern void user_rijndaelEncrypt(unsigned char *d);
extern void user_rijndaelDecrypt(unsigned char *d);
extern void bbpll_reset(void);



void aes_user_ecb_encryption(u8 *plaintext, u8 *result)
{
    u8 sk[16];
    int i;

    for (i = 0; i < 16; i++)
    {
        sk[i] = plaintext[i];
    }
#if (AES_METHOD==3)
    user_rijndaelEncrypt(sk);
#elif (AES_METHOD==2)
	user_rijndaelDecrypt(sk);
#endif
	for (i = 0; i < 16; i++)
    {
        result[i] = sk[i];
    }
}
void aes_user_ecb_Decrypt(u8 *plaintext, u8 *result)
{
    u8 sk[16];
    int i;

    for (i = 0; i < 16; i++)
    {
        //sk[i] = plaintext[15 - i];

        sk[i] = plaintext[i];
    }
    user_rijndaelDecrypt(sk);

    memcpy(result, sk, 16);
}

extern u32 dongle_id;


#if 0

void test_aes()
{

    u8 plaintext[16] =
    {
        0x4B, 0x59, 0x01, 0x00, 0x00, 0x00, 0x86, 0x00, 0x00, 0x00, 0x14, 0x12, 0x0A, 0x0B, 0x0C, 0x0D
    };

    u8 encrypted_data[16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    u8 decrypted_data[16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};


    u8 encrypted_data_result[16] =
    {
        0x94, 0x18, 0x89, 0xed, 0xe8, 0x3d, 0x13, 0x76, 0x68, 0x2e, 0x64, 0xfa, 0xe6, 0xee, 0x66, 0x31
    };



    //aes_user_decryption(encKey,encrypted_data,decrypted_data);
    //user_rijndaelDecrypt(encrypted_data);

    gpio_set_output_en(GPIO_GP4, 1);
    gpio_set_input_en(GPIO_GP4, 0);
    gpio_set_output_en(GPIO_GP2, 1);
    gpio_set_input_en(GPIO_GP2, 0);

    user_rijndaelSetKey(encKey);

#if 1

    while (1)
    {

        memset(encrypted_data, 0, 16);

        gpio_write(GPIO_GP4, 1);
        aes_user_ecb_encryption(plaintext, encrypted_data);
        gpio_write(GPIO_GP4, 0);

        if (memcmp(encrypted_data, encrypted_data_result, 16))
        {
            while (1)
            {
                gpio_write(GPIO_GP4, 1);
            }
        }
        sleep_us(200000);

        memset(decrypted_data, 0, 16);
        gpio_write(GPIO_GP2, 1);
        aes_user_ecb_Decrypt(encrypted_data_result, decrypted_data);
        gpio_write(GPIO_GP2, 0);

        if (memcmp(plaintext, decrypted_data, 16))
        {
            while (1)
            {
                gpio_write(GPIO_GP2, 1);
            }
        }
        sleep_us(200000);



    }
#endif


}
#endif
int main(void)
{

    cpu_wakeup_init();

    usb_dp_pullup_en(0);
	bbpll_reset();

    clock_init();

    dma_init();

    gpio_init();

    irq_init();

    usb_init();

    rf_drv_init(0);

    user_init();

    //test_aes();


    irq_enable();



    while (1)
    {
#if(MODULE_WATCHDOG_ENABLE)
        wd_clear();
#endif
        main_loop();



    }
}

#endif


