/********************************************************************************************************
 * @file     aaa_led.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2010, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/

#include "AAA_public_config.h"

typedef enum
{
	BAT_LVD_LED_PRIORITY,
	CONN_LED_PRIORITY,
	KEY_NEW_EVENT_LED_PRIORITY,
	RECONN_LED_PRIORITY,
	ADV_LED_PRIORITY,
	MODE_LED_PRIORITY,
}LED_CFG_ENUM_AAA;

#if 1
const led_cfg_t connected_led={100,	0,	0XFF,CONN_LED_PRIORITY};
const led_cfg_t key_new_led={100,	100,	1,	KEY_NEW_EVENT_LED_PRIORITY};

const led_cfg_t adv_24g_led={250,	250,	1,	ADV_LED_PRIORITY};
const led_cfg_t adv_ble_led={250,	250,	1,	ADV_LED_PRIORITY};

const led_cfg_t bat_lvd_led={125,	125 ,   3,	BAT_LVD_LED_PRIORITY};

const led_cfg_t mod_24_led=	{2000,	10,  1,	MODE_LED_PRIORITY};
const led_cfg_t mod_ble_led={4000,	10,	1,	MODE_LED_PRIORITY};

const led_cfg_t reconn_24g_led={1000,1000,	1,	RECONN_LED_PRIORITY};
const led_cfg_t reconn_ble_led={1000,1000,	1,	RECONN_LED_PRIORITY};



#endif
u8 kb_led_status;
void led_num_set(u8 status)
{
#if HAS_NUM_LED_AAA

	gpio_write(GPIO_LED_NUM,status);
#endif
}
void led_caps_set(u8 status)
{
#if HAS_CAPS_LED_AAA

	gpio_write(GPIO_LED_CAP,status);
#endif
}

void led_scroll_set(u8 status)
{
#if HAS_SCROLL_LED_AAA
	gpio_write(GPIO_LED_SCR,status);
#endif
}


void led_ble_Adv_poll()
{
	if(pair_flag)
	{
		device_led_setup(adv_ble_led);
	}
	else
	{
		//device_led_setup(reconn_ble_led);
	}
	#if (BLE_SNIFF_DEBUG)
        device_led_setup(reconn_ble_led);
	#endif
}
void led_2p4_Adv_poll()
{
	if(pair_flag)
	{
		device_led_setup(adv_24g_led);
	}
	else
	{
		//device_led_setup(reconn_24g_led);
	}
}

void led_ble_mode_test(){
	//gpio_set_output_en(PIN_24G_LED,1);
	//gpio_write(PIN_24G_LED,LED_ON_AAA);

	device_led_init(PIN_BLE_LED,LED_ON_AAA);
	device_led_setup(adv_ble_led);
}


void led_ble_mode_display()
{
	gpio_write(PIN_24G_LED,LED_OFF_AAA);

	device_led_init(PIN_BLE_LED,LED_ON_AAA);
	device_led_setup(mod_ble_led);
}
void led_24g_mode_display()
{
	gpio_write(PIN_BLE_LED,LED_OFF_AAA);
	device_led_init(PIN_24G_LED,LED_ON_AAA);
	device_led_setup(mod_24_led);

}
void led_bat_lvd()
{
	device_led_setup(bat_lvd_led);
}

void led_hw_init()
{
#if HAS_NUM_LED_AAA	
	gpio_set_output_en(GPIO_LED_NUM,1);
	gpio_write(GPIO_LED_NUM,LED_OFF_AAA);
#endif
#if HAS_CAPS_LED_AAA
	gpio_set_output_en(GPIO_LED_CAP,1);
	gpio_write(GPIO_LED_CAP,LED_OFF_AAA);
#endif

#if HAS_SCROLL_LED_AAA
	gpio_set_output_en(GPIO_LED_SCR,1);
	gpio_write(GPIO_LED_SCR,LED_OFF_AAA);
#endif
	#if 1
	if(fun_mode==RF_1M_BLE_MODE)
	{
		gpio_set_output_en(PIN_BLE_LED,1);
		gpio_write(PIN_BLE_LED,LED_OFF_AAA);
    	device_led_init(PIN_BLE_LED,LED_ON_AAA);
    	
	}
	else
	{
		gpio_set_output_en(PIN_24G_LED,1);
		gpio_write(PIN_24G_LED,LED_OFF_AAA);
    	device_led_init(PIN_24G_LED,LED_ON_AAA);
	}
	#endif
}

