/********************************************************************************************************
 * @file     aaa_public.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2010, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/

#include "AAA_public_config.h"

_attribute_data_retention_user  u8 device_name_len=0;
_attribute_data_retention_user  u8 connect_ok=0;

_attribute_data_retention_user u8 win_lock=0;
_attribute_data_retention_user u8 win_lock_flag=0;
_attribute_data_retention_user u8 keyboard_test_flag=0;
_attribute_data_retention_user kb_data_t	kb_event;
#if KEYBOARD_FUN_ENABLE_AAA
_attribute_data_retention_user u8 keyboard_buf_aaa[BUF_SIZE_KEYBOARD_AAA];
_attribute_data_retention_user u8 keyboard_buf_last_aaa[BUF_SIZE_KEYBOARD_AAA];
#endif
_attribute_data_retention_user  u8 active_disconnect_reason=0;
_attribute_data_retention_user  u8 enter_emi_flag=0;


void save_dev_info_flash()
{
    dev_info_idx += sizeof(FLASH_DEV_INFO_AAA);
    flash_write_page(CFG_DEVICE_MODE_ADDR + dev_info_idx, sizeof(FLASH_DEV_INFO_AAA), (u8 *)&flash_dev_info.dongle_id);
	//sleep_us(50000);
}

#if CONSUMER_FUN_ENABLE_AAA

#if CONSUMER_REPORT_BYTE_AAA
	u8 consumer_buf_aaa;
	u8 consumer_buf_last_aaa;
const u16 consumer_list[]={
0x221,		//0xa3 C_WWW_SEARCH		
0x223,		//0xa4 C_WWW_HOME
0x224,		//0xa5 C_WWW_BACKWARD
0x225,		//0xa6 C_WWW_FORWARD
0x226,		//0xa7 C_WWW_STOP
0x227,		//0xa8 C_WWW_REFRESH
0x22A,		//0xa9 C_MY_FAVORITE
0x183,		//0xaa C_MEDIA_SELECT
	
0x18A,		//0xab C_EMAIL
0x192,		//0xac C_CALCULATOR
0x194,		//0xad C_MY_COMPUTER
0xB5,		//0xae C_NEXT_TRACK
0xB6,		//0xaf C_PRE_TRACK
0xB7,		//0xb0 C_STOP
0xCD,		//0xb1 C_PLAY_PAUSE
0xE2,		//0xb2 C_MUTE	
	
0xE9,		//0xb3 C_VOL_INC
0xEA,		//0xb4 C_VOL_DEC	
0x00,		//0xb5 telinkԶ
0x22D,		//0xb6 USAGE ZOOM IN
0x22E,		//0xb7	 USAGE ZOOM OUT 
0x236,		//0xb8	 USAGE PAN LEFT
0x237,		//0xb9	 USAGE PAN RIGHT
0x30B,		//0xba	C_BRIGHT_INC	
	
0x30A,		//0xbb	C_BRIGHT_DEC
0xB8,		//0Xbc	 c_rject
0x30,		//0Xbd	C_POWER 		
0x19E,		//0Xbe	C_TERMINAL_LOCK 
};
#else
	u32 consumer_buf_aaa;
	u32 consumer_buf_last_aaa;
#endif
#if SYSTEM_KEY_FUN_ENABLE_AAA
    u8 system_buf_aaa;
    u8 system_buf_last_aaa;
#endif

#endif

_attribute_data_retention_user custom_cfg_t   user_cfg;
_attribute_data_retention_user u8 fun_mode=RF_1M_BLE_MODE;
_attribute_data_retention_user FLASH_DEV_INFO_AAA flash_dev_info;
_attribute_data_retention_user FLASH_DPI_INFO_AAA flash_dpi_info;


_attribute_data_retention_user u8 suspend_wake_up_enable=1;
_attribute_data_retention_user u8 deep_flag=POWER_ON_ANA_AAA;
_attribute_data_retention_user u8 pair_flag=0;


_attribute_data_retention_user u8 has_new_report_aaa;
_attribute_data_retention_user u8 has_new_key_event=0;


_attribute_data_retention_user u8 combination_flag=0;
_attribute_data_retention_user TX_FIFO_AAA_STRUCT tx_fifo_aaa;


_attribute_data_retention_user u8 btn_value=0;
_attribute_data_retention_user u8 last_btn_value=0;
_attribute_data_retention_user u8 mouse_btn_in_sensor;
//u8 last_mosue_btn_in_sensor;
_attribute_data_retention_user mouse_data_t ms_data;

_attribute_data_retention_user u8 wheel_pre=0;
_attribute_data_retention_user u8 wheel_status;

_attribute_data_retention_user u32 power_tick=0;

kb_data_t_aaa key_buf_aaa;

 
 void hw_init()
 {
     matrix_init_aaa();
	  
 #if BLT_APP_LED_ENABLE
 	 led_hw_init();
 #endif	
 	//get_data_report_aaa();
 }


 u8 push_data_fifo_aaa(u8 *buf,u8 data_type,u8 len)
{
	if ((tx_fifo_aaa.wptr-tx_fifo_aaa.rptr) >= TX_FIFO_NUM_AAA)
	{
		return 0;
	}
	
	TX_PACKET_AAA *p = (TX_PACKET_AAA *)tx_fifo_aaa.fifo[tx_fifo_aaa.wptr& (TX_FIFO_NUM_AAA-1)];
	p->type=data_type;
	p->len=len;
	
	memcpy (p->buf, buf,len);
	 
	tx_fifo_aaa.wptr++;
	return 1;
}
void push_report_fifo()
{
	#if 0
	if(has_new_report_aaa&HAS_MOUSE_REPORT)
	{

        if(combination_flag)
        {
			
memset(&ms_data.btn,0,sizeof(mouse_data_t));
        }
  
        if(fun_mode==RF_1M_BLE_MODE)
        {
			if(push_data_fifo_aaa(&ms_data.btn,HAS_MOUSE_REPORT,sizeof(mouse_data_t)))
			{
				has_new_report_aaa&=~HAS_MOUSE_REPORT;
			}
		}
		else
		{
			has_new_report_aaa&=~HAS_MOUSE_REPORT;
		}
        
	}
	#endif

#if CONSUMER_FUN_ENABLE_AAA
	
		if(has_new_report_aaa&HAS_CONSUMER_REPORT)
		{
			if(push_data_fifo_aaa((u8*)(&consumer_buf_aaa),HAS_CONSUMER_REPORT,BUF_SIZE_CONSUMER_AAA))
			{
			
				has_new_report_aaa&=~HAS_CONSUMER_REPORT;
			}
		}
#endif
	
#if KEYBOARD_FUN_ENABLE_AAA
		{
			if(has_new_report_aaa&HAS_KEYBOARD_REPORT)
			{
				
				if(push_data_fifo_aaa(keyboard_buf_aaa,HAS_KEYBOARD_REPORT,BUF_SIZE_KEYBOARD_AAA))
				{
					has_new_report_aaa&=~HAS_KEYBOARD_REPORT;
				}
			}
		}
#endif

#if SYSTEM_KEY_FUN_ENABLE_AAA

    if(has_new_report_aaa&HAS_SYSYTEM_REPORT)
	{
		
		if(push_data_fifo_aaa((u8*)(&system_buf_aaa),HAS_SYSYTEM_REPORT,1))
		{
			has_new_report_aaa&=~HAS_SYSYTEM_REPORT;
		}
	}
#endif

}

void ble_notify_data_proc_aaa()
{
	
	// u16 att_handle=0;
	 #if 0
	 if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
	 {
		 TX_PACKET_AAA *p = (TX_PACKET_AAA*)tx_fifo_aaa.fifo[tx_fifo_aaa.rptr& (TX_FIFO_NUM_AAA-1)];
	
		if(blc_ll_getTxFifoNumber() <10)
		{
			if(bls_att_pushNotifyData(21,p->buf,p->len)==BLE_SUCCESS)
			{
				tx_fifo_aaa.rptr++;
				 
memset(&ms_data.btn,0,sizeof(mouse_data_t));
				ret=1;
			}
		}		 
	 }
 #else
     u8 ret=0;
	 
	 if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
	 {
		 TX_PACKET_AAA *p = (TX_PACKET_AAA*)tx_fifo_aaa.fifo[tx_fifo_aaa.rptr& (TX_FIFO_NUM_AAA-1)];
		 if(combination_flag||active_disconnect_reason)
         {
 			memset(p->buf,0,p->len);
         }
		 
		 if(p->type==HAS_CONSUMER_REPORT)
		 {
		 	
			#if CONSUMER_REPORT_BYTE_AAA
			   u16 temp=0;
			 if(p->buf[0]!=0)
			 {
			 	temp=consumer_list[p->buf[0]-C_INDEX_START];
			 }
			 else
			 {
			 	 temp=0;
			 }
           
			u8 txFifoNumber = blc_ll_getTxFifoNumber();
	        if (txFifoNumber < RF_TX_FIFO_ALLOW_NUM)
	        {
				u8 status = bls_att_pushNotifyData(HID_CONSUME_REPORT_INPUT_DP_H,(u8*)&temp,2);
				if (status == BLE_SUCCESS)
				{
					 tx_fifo_aaa.rptr++;
					ret=1;
				}
#if UART_PRINT_DEBUG_ENABLE
	            else
	            {
	                my_printf_aaa("notify_fail_reason=%x\r\n", status);
	            }
#endif
	        }
			#else
			u8 txFifoNumber = blc_ll_getTxFifoNumber();
	        if (txFifoNumber < RF_TX_FIFO_ALLOW_NUM)
	        {
				u8 status = bls_att_pushNotifyData(HID_CONSUME_REPORT_INPUT_DP_H,(u8*)&temp,2);
				if (status == BLE_SUCCESS)
				{
					 tx_fifo_aaa.rptr++;
					ret=1;
				}
#if UART_PRINT_DEBUG_ENABLE
				else
				{
					my_printf_aaa("notify_fail_reason=%x\r\n", status);
				}
#endif

			}
			#endif
		 	
		 }
		 else if(p->type==HAS_KEYBOARD_REPORT)
		 {
		 	u8 txFifoNumber = blc_ll_getTxFifoNumber();
	        if (txFifoNumber < RF_TX_FIFO_ALLOW_NUM)
	        {
			 	//p->buf[1] = p->buf[0];
				u8 status = bls_att_pushNotifyData(HID_NORMAL_KB_REPORT_INPUT_DP_H,p->buf,p->len);	//HID_NORMAL_KB_REPORT_INPUT_DP_H
				if (status == BLE_SUCCESS)
				{
					tx_fifo_aaa.rptr++;
					ret=1;
				}
#if UART_PRINT_DEBUG_ENABLE
				else
				{
					my_printf_aaa("notify_fail_reason=%x\r\n", status);
				}
#endif
			 }
		 }
		 else if(p->type==HAS_SYSYTEM_REPORT)
		 {
             u8 temp=1<<(p->buf[0]-S_SLEEP);
			if(bls_att_pushNotifyData(HID_NORMAL_KB_SYSTEM_INPUT_DP_H,(u8*)&temp,1)==BLE_SUCCESS)
			{
				 tx_fifo_aaa.rptr++;
				ret=1;
			}
		 }
		 else
		 {
		 	tx_fifo_aaa.rptr++;
			ret=1;
		 }
		 
	 }
	 else if(active_disconnect_reason)
	 {
	 	u8 buf[8]={0,0,0,0,0,0,0,0};
		#if CONSUMER_REPORT_BYTE_AAA
		u8 consume_bytes=1;
		#else
		u8 consume_bytes=2;
		#endif
		bls_att_pushNotifyData(HID_NORMAL_KB_REPORT_INPUT_DP_H,buf,8);
		bls_att_pushNotifyData(HID_CONSUME_REPORT_INPUT_DP_H,buf,consume_bytes);
		bls_att_pushNotifyData(HID_NORMAL_KB_SYSTEM_INPUT_DP_H,buf,1);
	 	bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
	 }
 #endif
 	
}
u8 check_notify_fifo_empty_aaa()
{	
	return (tx_fifo_aaa.wptr==tx_fifo_aaa.rptr);	
}
void clear_fifo()
{
	tx_fifo_aaa.wptr=0;
	tx_fifo_aaa.rptr=0;
}
u8 clear_press_key_aaa()
{
	memset(keyboard_buf_aaa,0,8);
	consumer_buf_aaa=0;
#if KEYBOARD_FUN_ENABLE_AAA
	push_data_fifo_aaa(keyboard_buf_aaa,HAS_KEYBOARD_REPORT,BUF_SIZE_KEYBOARD_AAA);
#endif

#if CONSUMER_FUN_ENABLE_AAA
	push_data_fifo_aaa((u8*)(&consumer_buf_aaa),HAS_CONSUMER_REPORT,BUF_SIZE_CONSUMER_AAA);
#endif

#if SYSTEM_KEY_FUN_ENABLE_AAA
	system_buf_aaa=0;
	push_data_fifo_aaa((u8*)(&system_buf_aaa),HAS_SYSYTEM_REPORT,1);
#endif

   return 1;
}
#if (IS_SINGLE_GPIO_CHANGE_MODE)
 void sing_gpio_mode_poll()
{
	_attribute_data_retention_user static u32 tick;
	  if(IS_BLE_MODE_AAA)
	{
		flash_dev_info.mode=RF_1M_BLE_MODE;
	}
	else
	{
		flash_dev_info.mode=RF_2M_2P4G_MODE;
	}
	 if(fun_mode!=flash_dev_info.mode)
	 {
		 if(clock_time_exceed(tick,300000))
		 {
		 	user_reboot(BLE_PAIR_REBOOT_ANA_AAA);
		 }
	 }
	 else
	 {
	 	tick=clock_time();
	 }
}	
#endif
 
 void mouse_task_when_rf()
 {

 }
 void set_special_key_flag_aaa(u8 key_code)
{
	if(!key_code)  //key_code=0 not save
	return;
	
	if(key_code==T_FN)
	{
		key_buf_aaa.special_key_press_f|=FN_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_Esc)
	{
		key_buf_aaa.special_key_press_f|=T_ESC_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_Q)
	{
		key_buf_aaa.special_key_press_f|=T_Q_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_W)
	{
		key_buf_aaa.special_key_press_f|=T_W_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_E)
	{
		key_buf_aaa.special_key_press_f|=T_E_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_R)
	{
		key_buf_aaa.special_key_press_f|=T_R_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_T)
	{
		key_buf_aaa.special_key_press_f|=T_T_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_Y)
	{
		key_buf_aaa.special_key_press_f|=T_Y_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_U)
	{
		key_buf_aaa.special_key_press_f|=T_U_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_I)
	{
		key_buf_aaa.special_key_press_f|=T_I_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_O)
	{
		key_buf_aaa.special_key_press_f|=T_O_PRESS_AAA;
		return ;
	}
	else if(key_code==T_bind)
	{
		key_buf_aaa.special_key_press_f|=T_BIND_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_F1)
	{
		key_buf_aaa.special_key_press_f|=T_F1_PRESS_AAA;
		return ;
	}
	else if(key_code==KB_Space)
	{
		key_buf_aaa.special_key_press_f|=T_SPACE_PRESS_AAA;
		return ;
	}

}
void key_fifo(u8 key_code)
{
	key_buf_aaa.cnt++;
	if(key_buf_aaa.cnt > MAX_BTN_CNT_AAA)
	{
		return;
	}
	key_buf_aaa.keycode[key_buf_aaa.cnt-1] = key_code;
}

 void oneKey_power_process()
 {
#if HAS_SOFT_POWER_KEY_AAA
#endif
 }
 void oneKey_bind_process()
 {
 
 }
 void oneKey_keyboard_process()
 {	 
	 key_fifo(C_RJECT);
 }
 void oneKey_lock_process()
 {
	 key_fifo(C_POWER);
	 
	 key_fifo(KB_LWin);
	 key_fifo(KB_L);
 }
 void oneKey_brightDN_process()
 {
	 key_fifo(KB_F1);
	 
 }
 
 void oneKey_brightUP_process()
 {
	 key_fifo(KB_F2);
 
 }
 
 
 void oneKey_languageC_process()
 {
	 key_fifo(KB_LCtrl);
	 key_fifo(KB_Space);
	 //key_fifo(KB_LShift);
	 
 }
 void oneKey_copy_process()
 {
	 
 }
 void oneKey_paste_process()
 {
	 
 }
 
 void oneKey_shear_process()
 {
	 
 }
 void oneKey_phone_process()
 {
	 
 }
 void oneKey_SHIFTK45_process()
 {
	 key_fifo(KB_LShift);
	 key_fifo(KB_K45);
 }
 void oneKey_ALTK45_process()
 {
	 key_fifo(KB_RAlt);
	 key_fifo(KB_K45);
 }
 void oneKey_PrtSc_process()
 {
	 key_fifo(C_POWER);
	 key_fifo(C_wHome);
 }
 void oneKey_backLight_process()
 {
#if HAS_BACK_LIGHT_AAA
#if TIME_RGB_ENABLE_AAA
	 if(back_light_switch_flag==BACK_LIGHT_ON)
	 {
		 back_light_switch_flag=BACK_LIGHT_OFF;
		 light_hw_timer1_OnOFF(0);
	 }
	 else
	 {
		 back_light_switch_flag=BACK_LIGHT_ON;
		 light_hw_timer1_OnOFF(1);
	 }
#else
	 
	 back_light_switch_flag=(back_light_switch_flag+1)%4;
	 reg_display();
	 
	 back_light_flash_idx += 4;
	 flash_write_page((CFG_BACK_COLOR_ADDR+back_light_flash_idx), 4, (u8*)&back_light_switch_flag);
 
	
	 
	 
	 
#endif
#endif
 }
  void oneKey_TaskManager_process()
  {
	  key_fifo(KB_LCtrl);
	  key_fifo(KB_LAlt);
	  key_fifo(KB_Delete);
  }
  
  void (*onekey_func[]) (void)=
  {
	  oneKey_power_process,
	  oneKey_bind_process,
	  oneKey_keyboard_process,
	  oneKey_lock_process,
	  oneKey_brightDN_process,
	  oneKey_brightUP_process,
	  oneKey_languageC_process,
	  oneKey_copy_process,
	  oneKey_paste_process,
	  oneKey_shear_process,
	  oneKey_phone_process,
	  oneKey_PrtSc_process,
	  oneKey_backLight_process,
	  oneKey_TaskManager_process,
	  oneKey_SHIFTK45_process,
	  oneKey_ALTK45_process,
	  
  };

 u8 special_key_process(u8 key_code)
 {
	 if(key_buf_aaa.special_key_press_f&FN_PRESS_AAA)
	 {
		 if(key_code==KB_F1)
		 {
			 key_fifo(S_SLEEP);
			 return 1;
		 }
		 else if(key_code==KB_F2)
		 {
			 key_fifo(KB_LWin);
			 key_fifo(KB_L);
			 return 1;
		 }
		 else if(key_code==KB_F3)
		 {
			 key_fifo(KB_LWin);
			 key_fifo(KB_E);
			 return 1;
		 }
		 else if(key_code==KB_F4)
		 {
			 key_fifo(KB_LWin);
			 key_fifo(KB_P);
			 return 1;
		 }
		 else if(key_code==KB_F5)
		 {
			 key_fifo(KB_LCtrl);
			 key_fifo(KB_LAlt);
			 key_fifo(KB_F16);
			 return 1;
		 }
		 else if(key_code==KB_F6)
		 {
			 key_fifo(KB_LCtrl);
			 key_fifo(KB_LAlt);
			 key_fifo(KB_F17);
			 return 1;
		 }
		 else if(key_code==KB_F8)
		 {
			 key_fifo(KB_LWin);
			 key_fifo(KB_LShift);
			 key_fifo(KB_F21);
			 return 1;
		 }
		 else if(key_code==KB_F9)
		 {
			 key_fifo(KB_LWin);
			 key_fifo(KB_LCtrl);
			 key_fifo(KB_F21);
			 return 1;
		 }
		 else if(key_code==KB_F10)
		 {
			 key_fifo(KB_PrtSc);
			 return 1;
		 }
	 }
	 return 0;
 }
 //u32 test_nt =0;
 void save_key_aaa(u8 key_code)
 {
	 /*if(key_code==KB_WIN_LOCK)
	 {
		 if(win_lock_flag == 0){
			 win_lock_flag = 1;
			 win_lock = ~win_lock;
		 }
	 }
	 else{
		 win_lock_flag = 0;
	 }*/
	 #if 0
	 test_nt++;
	 if(test_nt==6){
	 	key_fifo(KB_Q);
	 }else if(test_nt==12){
	 	key_fifo(KB_W);
	 }else if(test_nt==18){
	 	key_fifo(KB_E);
	 }else if(test_nt==24){
	 	key_fifo(KB_R);
	 }else if(test_nt==30){
	 	key_fifo(KB_T);
	 }else if(test_nt==36){
	 	key_fifo(KB_Y);
	 }else if(test_nt==42){
	 	key_fifo(KB_U);
	 }else if(test_nt==48){
	 	key_fifo(KB_I);
	 }else if(test_nt==54){
	 	key_fifo(KB_O);
	 }else if(test_nt==60){
	 	key_fifo(KB_P);
		test_nt = 0;
	 }
	 #endif
	 if((key_code==0)||(key_code==T_FN) ||(key_code==KB_WIN_LOCK)) //key_code=0 not save
	 return;
	 
/*	 if(win_lock){
		 if((key_code==KB_LWin)||(key_code==KB_RWin)){
			 return;
		 }
	 }
	 if(special_key_process(key_code))
	 {
		 return;
	 }*/
 
	 if((key_code>=T_INDEX_START)&&(key_code<=T_INDEX_END))
	 {
		 onekey_func[key_code-T_INDEX_START]();
		 
		 return;
	 }
	 key_fifo(key_code);
 }

 u8 proc_hotkey_aaa(u8 key_code)
 {
#if KEYBOARD_FUN_ENABLE_AAA
	 if((key_code>=0xe0)&&(key_code<0xe8))
	 {
		 keyboard_buf_aaa[0]|=(1<<(key_code-0xe0));
		 return 1;
	 } 
#endif
#if CONSUMER_FUN_ENABLE_AAA
 
	 
#if CONSUMER_REPORT_BYTE_AAA
	if((key_code>=C_INDEX_START)&&(key_code<=C_INDEX_END))
	{
		consumer_buf_aaa=key_code;
		return 1;
	}
#else
	if((key_code>=C_INDEX_START)&&(key_code<=C_INDEX_END))
	{
		u8 index=key_code-C_INDEX_START;
		consumer_buf_aaa|=(1<<index);
		return 1;
	} 
#endif
	 
#endif
  
#if SYSTEM_KEY_FUN_ENABLE_AAA
	  
	  if((key_code>=S_SLEEP)&&(key_code<=S_WAKEUP))
	  {
		  system_buf_aaa=key_code;
		  return 1;
	  }
#endif

	  if(key_code>0x9f)
	 {
		 return 1;
	 }
 
	 return 0;
 }
 
  void key_data_handle_aaa()
 {
	 u8 i,normal_cnt;
	 normal_cnt=2;
	 for(i=0;i<key_buf_aaa.cnt;i++)
	 {
		 if(proc_hotkey_aaa(key_buf_aaa.keycode[i])==0)
		 {
#if KEYBOARD_FUN_ENABLE_AAA
			 keyboard_buf_aaa[normal_cnt++]=key_buf_aaa.keycode[i];
#endif
		 }	 
	 }
#if KEYBOARD_FUN_ENABLE_AAA
	 for(i=0;i<BUF_SIZE_KEYBOARD_AAA;i++)
	 {
		 if(keyboard_buf_last_aaa[i]!=keyboard_buf_aaa[i])
		 {
			 keyboard_buf_last_aaa[i]=keyboard_buf_aaa[i];
			 has_new_report_aaa|=HAS_KEYBOARD_REPORT;
		 }
	 }
#endif
#if CONSUMER_FUN_ENABLE_AAA
 
	 if(consumer_buf_last_aaa!=consumer_buf_aaa)
	 {
		 consumer_buf_last_aaa=consumer_buf_aaa;
		 has_new_report_aaa|=HAS_CONSUMER_REPORT;
	 }
#endif 

#if SYSTEM_KEY_FUN_ENABLE_AAA

    if(system_buf_last_aaa!=system_buf_aaa)
	{
		system_buf_last_aaa=system_buf_aaa;
		has_new_report_aaa|=HAS_SYSYTEM_REPORT;
	}
#endif 
 }

 void clear_pair_flag()
 {
	 pair_flag=0;
	 analog_write(DEEP_ANA_REG1,0);
 }
 void set_pair_flag()
 {
	 pair_flag=1;
	 analog_write(DEEP_ANA_REG1,1);
 }
 void write_deep_ana0(u8 buf)
 {
	 deep_flag = buf;
	 analog_write(DEEP_ANA_REG0, buf);
 }
 void user_reboot(u8 reason)
 {
	 write_deep_ana0(reason);
	 start_reboot();
 
 }

 #if 0
   u8 get_ble_data_report_aaa()
  {
	  combination_flag=0;
	//	s8 buf[2]={0,0};
	 

	 if(has_new_key_event&(NEW_KEY_EVENT_AAA))
	 {	 	
		has_new_report_aaa|=HAS_MOUSE_REPORT;
		
	 }

	 
	push_report_fifo();
	return has_new_key_event;
	
}
	
void get_24g_data_report_aaa()
{
	combination_flag=0;
	
		
#if 0
	 if(has_new_key_event)
	 {		
		has_new_report_aaa|=HAS_MOUSE_REPORT;
		
	 }
	 push_report_fifo();
#endif
	
}
#endif
void led_show_mode()
{
#if BLT_APP_LED_ENABLE

    if ((deep_flag == POWER_ON_ANA_AAA) || (deep_flag == MODE_CHANGE_REBOOT_ANA_AAA))
    {
        if (deep_flag == MODE_CHANGE_REBOOT_ANA_AAA)
        {
            write_deep_ana0(CLEAR_FLAG_ANA_AAA);
        }
		if(fun_mode==RF_1M_BLE_MODE)
		{
        	led_ble_mode_display();
		}
		else
		{
			led_24g_mode_display();
		}

    }
#endif

}

void change_mode_aaa111()
{
#if (IS_SINGLE_GPIO_CHANGE_MODE)
	if(gpio_read(GPIO_PC2))
	{
		flash_dev_info.mode=RF_1M_BLE_MODE;
	}
	else
	{
		flash_dev_info.mode=RF_2M_2P4G_MODE;
	}
	if(fun_mode!=flash_dev_info.mode)
	{
		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#else


   static u32 tick;
   static u8 mode_change_flag_aaa;
 //  if((key_buf_aaa.special_key_press_f==(T_ESC_PRESS_AAA|FN_PRESS_AAA))||(key_buf_aaa.special_key_press_f==(T_F1_PRESS_AAA|FN_PRESS_AAA)))
   if(key_buf_aaa.special_key_press_f==(T_Q_PRESS_AAA|T_ESC_PRESS_AAA))
   {
	   
		combination_flag=1;
		//if(clock_time_exceed(tick,2000000))
		if(mode_change_flag_aaa==0)
		{
			mode_change_flag_aaa=1;

			clear_pair_flag();

			if(fun_mode==RF_2M_2P4G_MODE)
			{
				led_ble_mode_display();
			}
			else
			{
#if 0
			if(blc_ll_getCurrentState()==BLS_LINK_STATE_CONN)
			{				
				clear_press_key_aaa(); 
			}
#endif
				led_24g_mode_display();
			}
		}
   }
   else
   {
		tick=clock_time();
		if(mode_change_flag_aaa==1)
		{
			if(fun_mode==RF_2M_2P4G_MODE)
			{
				mode_change_flag_aaa=2; 
			}
			else if(check_notify_fifo_empty_aaa()&&(blc_ll_getCurrentState()==BLS_LINK_STATE_CONN))
			{
				bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
				ble_status_aaa=MODE_CHANGE_TERMINATE_STATUS_AAA;
			}
			else
			{
				mode_change_flag_aaa=2;
			}
		}
		else if((mode_change_flag_aaa==2)&&(!DEVICE_LED_BUSY))
		{
			if (fun_mode == RF_1M_BLE_MODE)
            {
                if (connect_ok)
                {
                    bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
                    ble_status_aaa = MODE_CHANGE_TERMINATE_STATUS_AAA;
                }
                else
                {
                    flash_dev_info.mode = RF_2M_2P4G_MODE;
                    save_dev_info_flash();
                    user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
                }

            }
            else
            {
                flash_dev_info.mode = RF_1M_BLE_MODE;
                save_dev_info_flash();
                user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
            }
			
		}
		
   }
   
#endif 
 

 }

void change_mode_aaa()
{

   static u8 mode_change_flag_aaa;
 //  if((key_buf_aaa.special_key_press_f==(T_ESC_PRESS_AAA|FN_PRESS_AAA))||(key_buf_aaa.special_key_press_f==(T_F1_PRESS_AAA|FN_PRESS_AAA)))
   if(key_buf_aaa.special_key_press_f==(T_Q_PRESS_AAA|T_ESC_PRESS_AAA))
   {
	   mode_change_flag_aaa=1;
	   combination_flag=1;
   }
   else
   {
   	    if(mode_change_flag_aaa==1)
   	    {
				mode_change_flag_aaa=0;
				clear_pair_flag();
				if (fun_mode == RF_1M_BLE_MODE)
                {
                  	if(connect_ok)
					{
						active_disconnect_reason=MODE_CHANGE_REBOOT_ANA_AAA;
					}
					else
					{
						flash_dev_info.mode = RF_2M_2P4G_MODE;
        				save_dev_info_flash();
        				user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
					}
                }
                else
                {
                   
                	flash_dev_info.mode = RF_1M_BLE_MODE;
                	save_dev_info_flash();
                	user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
            
                }
		

        	}
   }
 }

u8 get_data_report_aaa()
{
	u8 has_new_key_event=0;
	combination_flag=0;

    has_new_key_event|=matrix_scan_aaa();
	if(has_new_key_event)
	{
#if KEYBOARD_FUN_ENABLE_AAA
		memset(keyboard_buf_aaa,0,BUF_SIZE_KEYBOARD_AAA);
#endif

#if CONSUMER_FUN_ENABLE_AAA
		consumer_buf_aaa=0;
#endif
#if SYSTEM_KEY_FUN_ENABLE_AAA

      system_buf_aaa=0;
#endif		
		key_data_handle_aaa();	
	}

	change_mode_aaa();
   
	push_report_fifo();
   
	return has_new_key_event;
	
}


